using Newtonsoft.Json.Schema;
using System;

namespace InABox.Core
{
    public class DFLayoutIntegerFieldProperties : DFLayoutFieldProperties<int>
    {
        public DFLayoutIntegerFieldProperties()
        {
            Format = "";
        }

        public string Format { get; set; }

        public override string FormatValue(object? value)
        {
            return string.Format("{0" + (string.IsNullOrWhiteSpace(Format) ? "" : ":" + Format) + "}", value);
        }

        public override object? ParseValue(object? value)
        {
            if (value is null)
                return null;

            if (value.GetType().IsNumeric())
            {
                return Convert.ToInt32(value);
            }
            if (int.TryParse(value as string, out var result))
                return result;
            return null;
        }

        protected override void LoadProperties()
        {
            base.LoadProperties();
            Format = GetProperty("Format", Format);
        }

        protected override void SaveProperties()
        {
            base.SaveProperties();
            SetProperty("Format", Format);
        }
    }
}